#include "blocks/_cl.h"

#include "ming.h"

extern int SWF_gNumCharacters;

int SWF_versionNum = 5;

float Ming_scale = 20.0;
int Ming_cubicThreshold = 10000;

/* module-wide initialization.  return non-zero if error. */

WM_DLL_A int WM_DLL_B Ming_init()
{
#ifdef cl_win
#ifdef _DEBUG
#ifdef cl_MSVC_debug_mem_leak_tests
 {
  // check for memory leaks
  int tmpFlag = _CrtSetDbgFlag( _CRTDBG_REPORT_FLAG );
  tmpFlag |= _CRTDBG_LEAK_CHECK_DF|_CRTDBG_CHECK_ALWAYS_DF;
  _CrtSetDbgFlag( tmpFlag );
}
#endif
#endif
#endif
  SWF_gNumCharacters = 0;
  SWF_versionNum = 5;

  Ming_cubicThreshold = 10000;
  Ming_scale = 20.0;

  return 0;
}

WM_DLL_A int WM_DLL_B Ming_cleanup()
{
 // if you use this, then just allocate fills
 // and shapes without freeing them yourself
 // - you need to keep the anyway till the movie
 // is output., - and you shouldn't
 // clean them up yourself at end of movie 
 // - call this routine when the movie has
 // been output.
 // Gets called by MingCloseMovie()
 // in the windows GDI routine time approach
 MingRemoveAllDestructibleBlocks();
 MingRemoveAllFills();
 MingRemoveAllGradients();
 MingCloseAllFiles();
#ifdef cl_mem_leak_check
  if(Ming_MemLeakCheckAndFree())
  {
   printf("\npress any key to exit\n");
   getchar();
  }
#endif
 return 0;
}


WM_DLL_A void WM_DLL_B Ming_setScale(float scale)
{
  Ming_scale = scale;
}

WM_DLL_A float WM_DLL_B Ming_getScale(void)
{
  return Ming_scale;
}

WM_DLL_A void WM_DLL_B Ming_setCubicThreshold(int num)
{
  Ming_cubicThreshold = num;
}


WM_DLL_A void WM_DLL_B Ming_setWarnFunction(void (*warn)(char *msg, ...))
{
  setSWFWarnFunction(warn);
}

WM_DLL_A void WM_DLL_B Ming_setErrorFunction(void (*error)(char *msg, ...))
{
  setSWFErrorFunction(error);
}

WM_DLL_A void WM_DLL_B Ming_useSWFVersion(int version)
{
  if(version < 4 || version > 5)
    SWF_error("Only SWF versions 4 and 5 are currently supported!\n");

  SWF_versionNum = version;
}

WM_DLL_A int WM_DLL_B Ming_MemLeakCheckAndFree(void)
{
 return MemLeakCheckAndFree();
}

