/*
    Ming, an SWF output library
    Copyright (C) 2001  Opaque Industries - http://www.opaque.net/

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* movie.h */

#ifndef MING_MOVIE_H_INCLUDED
#define MING_MOVIE_H_INCLUDED

#include "blocks/swf.h"
#include "libming.h"
#include "displaylist.h"

struct _swfMovie
{
  SWFBlockList blockList;
  SWFDisplayList displayList;
  float rate;
  SWFRect bounds;
  unsigned short nFrames;
  unsigned short totalFrames;
  byte version;

  /* export items */
  short nExports;

  struct swfexport
  {
    SWFBlock block;
    char *name;
  } *exports;
};
typedef struct _swfMovie *SWFMovie;

#define SWFMOVIE_SIZE sizeof(struct _swfMovie)

WM_DLL_A void WM_DLL_B destroySWFMovie(SWFMovie movie);
WM_DLL_A SWFMovie WM_DLL_B newSWFMovie();
WM_DLL_A SWFMovie WM_DLL_B newSWFMovieWithVersion(int version);

WM_DLL_A void WM_DLL_B SWFMovie_setRate(SWFMovie movie, float rate);
WM_DLL_A void WM_DLL_B SWFMovie_setDimension(SWFMovie movie, float x, float y);
WM_DLL_A void WM_DLL_B SWFMovie_setNumberOfFrames(SWFMovie movie, int frames);

/* XXX - 0.1 name: */
#define SWFMovie_setFrames SWFMovie_setNumberOfFrames

WM_DLL_A void WM_DLL_B SWFMovie_setBackground(SWFMovie movie, int r, int g, int b);

WM_DLL_A void WM_DLL_B SWFMovie_setSoundStream(SWFMovie movie, SWFSound sound);

WM_DLL_A void WM_DLL_B SWFMovie_addBlock(SWFMovie movie, SWFBlock block);

WM_DLL_A void WM_DLL_B MingRecordDisplayItemAdded(SWFDisplayItem item);
WM_DLL_A void WM_DLL_B MingUnRecordDisplayItemRemoved(SWFDisplayItem item);
// this is needed at end of each frame if you want to clear it
// for next one
WM_DLL_A void WM_DLL_B MingRemoveAllDisplayItems(char remove_forgotten_items);

// but if you want to keep one of the items, e.g. a bitmap filled square:
WM_DLL_A void WM_DLL_B MingForgetDisplayItem(SWFDisplayItem item);
WM_DLL_A void WM_DLL_B MingRememberAllDisplayItems(SWFDisplayItem item);


WM_DLL_A SWFDisplayItem WM_DLL_B SWFMovie_add(SWFMovie movie, SWFBlock block);
WM_DLL_A void WM_DLL_B SWFMovie_remove(SWFMovie movie, SWFDisplayItem item);
WM_DLL_A void WM_DLL_B SWFMovie_nextFrame(SWFMovie movie);
WM_DLL_A void WM_DLL_B SWFMovie_labelFrame(SWFMovie movie, char *label);

WM_DLL_A void WM_DLL_B SWFMovie_addExport(SWFMovie movie, SWFBlock block, char *name);

WM_DLL_A int WM_DLL_B SWFMovie_output_for_file_name(SWFMovie movie, char *szOutputFile);
WM_DLL_A int WM_DLL_B SWFMovie_output(SWFMovie movie, SWFByteOutputMethod method, void *data);
WM_DLL_A int WM_DLL_B SWFMovie_save(SWFMovie movie, char *filename);


#endif /* MING_MOVIE_H_INCLUDED */
