/*
  warning:
  this is not a concise demonstration of the c interface to ming.
  this is a shell for new functions so that I can easily load them into gdb
  and a quick way to check for linkage errors.
  I make no guarantee that this represents the latest incarnation of the ming
  api..
*/
#include "blocks/dll_exports.h"
#include "blocks/_cl.h"
#include <time.h>
#include "ming.h"
#include "blocks/MemLeakCheck.h"

#define WIDTH 600
#define HEIGHT 400
SWFDisplayItem testRectangle(SWFMovie movie,byte rfill, byte gfill, byte bfill, byte afill
               ,byte routline, byte goutline, byte boutline, byte aoutline
               ,int width
               );
SWFDisplayItem testGradientFillRectangle(SWFMovie movie,byte rfill, byte gfill, byte bfill, byte afill
               ,byte rfill2, byte gfill2, byte bfill2, byte afill2
               ,byte routline, byte goutline, byte boutline, byte aoutline
               ,int width
               ,int degrees
               );


SWFDisplayItem testJpegFilledRectangle(SWFMovie movie
               ,char *szJpegFileName
               ,byte routline, byte goutline, byte boutline, byte aoutline
               ,int width
               )
{

   SWFShape shape = newSWFShape();
   SWFFill fill;
   SWFJpegBitmap jpeg = newSWFJpegBitmapForFileName(szJpegFileName);
   if(!jpeg)
   {
     printf("Couldn't find %s file!\n",szJpegFileName);
     printf("Press any key to exit\n");
     getchar();
     exit(1);
   }
   fill = SWFShape_addBitmapFill(shape, jpeg, SWFFILL_TILED_BITMAP);
   SWFShape_setRightFill(shape, fill);
   SWFShape_setLine(shape, (unsigned short)width, routline, goutline, boutline, aoutline);
   SWFShape_movePenTo(shape, (float)width, (float)width);
   SWFShape_drawLineTo(shape,(float) WIDTH-width, (float)width);
   SWFShape_drawLineTo(shape,(float) WIDTH-width, (float)HEIGHT-width);
   SWFShape_drawLineTo(shape, (float)width,(float) HEIGHT-width);
   SWFShape_drawLineTo(shape, (float)width, (float)width);
   SWFShape_end(shape);

   return SWFMovie_add(movie, shape);
}

SWFDisplayItem testPngFilledRectangle(SWFMovie movie
               ,char *szPngAsDblFileName
               ,byte routline, byte goutline, byte boutline, byte aoutline
               ,int width
               )
{
 // you have to convert the png file to a dbl using the png2dbl utility
   SWFShape shape = newSWFShape();
   SWFFill fill;
   SWFDBLBitmap dbl = newSWFDBLBitmapForFileName(szPngAsDblFileName);
   if(!dbl)
   {
     printf("Couldn't find %s file!\n",szPngAsDblFileName);
     printf("Press any key to exit\n");
     getchar();
     exit(1);
   }
   fill = SWFShape_addBitmapFill(shape, dbl, SWFFILL_TILED_BITMAP);
   SWFShape_setRightFill(shape, fill);
   SWFShape_setLine(shape, (unsigned short)width, routline, goutline, boutline, aoutline);
   SWFShape_movePenTo(shape, (float)width, (float)width);
   SWFShape_drawLineTo(shape,(float) WIDTH-width, (float)width);
   SWFShape_drawLineTo(shape,(float) WIDTH-width, (float)HEIGHT-width);
   SWFShape_drawLineTo(shape, (float)width,(float) HEIGHT-width);
   SWFShape_drawLineTo(shape, (float)width, (float)width);
   SWFShape_end(shape);

   return SWFMovie_add(movie, shape);
}



/* {{{ testCubic */

SWFDisplayItem testCubic(SWFMovie movie)
{
  {
   float ax = (float)(rand()%WIDTH), ay = (float)(rand()%HEIGHT);
   float bx = (float)(rand()%WIDTH), by = (float)(rand()%HEIGHT);
   float cx = (float)(rand()%WIDTH), cy = (float)(rand()%HEIGHT);
   float dx = (float)(rand()%WIDTH), dy = (float)(rand()%HEIGHT);

   SWFShape shape = newSWFShape();
   SWFShape outline = newSWFShape();

   SWFShape_setLine(shape, 20, 0, 0, 0, 0xff);

   SWFShape_movePenTo(shape, ax, ay);
   SWFShape_drawCubic(shape, bx, by, cx, cy, dx, dy);

   SWFMovie_add(movie, shape);

   SWFShape_movePenTo(outline, ax, ay);
   SWFShape_setLine(outline, 20, 0xff, 0, 0, 0x9f);
   SWFShape_drawLineTo(outline, bx, by);
   SWFShape_drawLineTo(outline, cx, cy);
   SWFShape_drawLineTo(outline, dx, dy);
   SWFShape_movePenTo(outline, ax, ay);
   SWFShape_setLine(outline, 100, 0xff, 0, 0, 0x9f);
   SWFShape_drawLine(outline, 1, 0);
   SWFShape_movePenTo(outline, bx, by);
   SWFShape_drawLine(outline, 1, 0);
   SWFShape_movePenTo(outline, cx, cy);
   SWFShape_drawLine(outline, 1, 0);
   SWFShape_movePenTo(outline, dx, dy);
   SWFShape_drawLine(outline, 1, 0);

   return SWFMovie_add(movie, outline);
  }
}

/* }}} */
/* {{{ testDrawCharacter */


SWFDisplayItem testDrawCharacter(SWFMovie movie)
{
  SWFShape shape = newSWFShape();
  SWFFont f =loadSWFFontFromFileOfName("verdana.fdb");
  SWFDisplayItem i;
  float space_width=0;

  SWFFill f1, f2, f3, f4;

  if(f == NULL)
  {
    puts("verdana.fdb not found!");
    printf("Press any key to exit\n");
    getchar();
    exit(1);
  }
  space_width=SWFFont_getStringWidth(f, " ");
  f1 = SWFShape_addSolidFill(shape, 0xff, 0, 0, 0xff);
  SWFShape_setRightFill(shape, f1);
  SWFShape_setLine(shape, 2, 0x7f, 0, 0, 0xff);
  SWFShape_drawFontGlyph(shape, f, '&');
  SWFShape_movePen(shape, (float)SWFFont_getStringWidth(f, "&")+space_width, 0);

  f2 = SWFShape_addSolidFill(shape, 0xff, 0xff, 0, 0xff);
  SWFShape_setRightFill(shape, f2);
  SWFShape_setLine(shape, 2, 0x7f, 0xff, 0, 0xff);
  SWFShape_drawFontGlyph(shape, f, 'a');
  SWFShape_movePen(shape, (float)SWFFont_getStringWidth(f, "a")+space_width, 0);

  f3 = SWFShape_addSolidFill(shape, 0, 0xff, 0, 0xff);
  SWFShape_setRightFill(shape, f3);
  SWFShape_setLine(shape, 2, 0, 0x7f, 0xff, 0xff);
  SWFShape_drawFontGlyph(shape, f, 'b');
  SWFShape_movePen(shape, (float)SWFFont_getStringWidth(f, "b")+space_width, 0);

  f4 = SWFShape_addSolidFill(shape, 0, 0, 0xff, 0xff);
  SWFShape_setRightFill(shape, f4);
  SWFShape_setLine(shape, 2, 0, 0, 0x7f, 0xff);
  SWFShape_drawFontGlyph(shape, f, 'c');

  SWFShape_end(shape);

  i = SWFMovie_add(movie, shape);

  SWFDisplayItem_moveTo(i, 0, HEIGHT/2);
  SWFDisplayItem_scaleTo(i, 3,3);
  return i;
}

/* }}} */
/* {{{ testDBL */

SWFDisplayItem testDBL(SWFMovie movie)
{
  SWFFill fill;
  SWFDBLBitmap dbl;
  SWFShape shape;
  SWFDisplayItem i;
  dbl = newSWFDBLBitmapForFileName("test.dbl");
  if(!dbl)
  {
    printf("Couldn't find test.dbl file!\n");
    printf("Press any key to exit\n");
    getchar();
    exit(1);
  }

  shape = newSWFShape();

  fill = SWFShape_addBitmapFill(shape, dbl, SWFFILL_CLIPPED_BITMAP);
  SWFShape_setRightFill(shape, fill);
  SWFShape_lineToRelative(shape, 640, 0);
  SWFShape_lineToRelative(shape, 0, 640);
  SWFShape_lineToRelative(shape, -640, 0);
  SWFShape_lineToRelative(shape, 0, -640);

  return i = SWFMovie_add(movie, shape);
}


/* }}} */
/* {{{ testMorph */

SWFDisplayItem testMorph(SWFMovie movie)
{
  SWFMorph morph = newSWFMorphShape();
  SWFShape shape1 = SWFMorph_getShape1(morph);
  SWFShape shape2 = SWFMorph_getShape2(morph);
  SWFDisplayItem d;
  int i;

  SWFShape_moveTo(shape1, 0, 0);
  SWFShape_moveTo(shape2, 0, 0);

  SWFShape_setLineStyle(shape1, 20, 0, 0, 0, 0xff);
  SWFShape_setLineStyle(shape2, 20, 0, 0, 0, 0xff);

  for(i=0; i<20; ++i)
  {
    SWFShape_lineTo(shape1, rand()%2000-1000, rand()%2000-1000);
    SWFShape_lineTo(shape2, rand()%2000-1000, rand()%2000-1000);
  }

  d = SWFMovie_add(movie, morph);

  for(i=0; i<10; ++i)
  {
    SWFDisplayItem_setRatio(d, (float)((i*65535)/10));
    SWFMovie_nextFrame(movie);
  }
  for(; i>0; --i)
  {
    SWFDisplayItem_setRatio(d, (float)((i*65535)/10));
    SWFMovie_nextFrame(movie);
  }
  return d;
}

/* }}} */
/* {{{ testJpeg */

void testJpeg(SWFMovie movie)
{
  SWFFill fill;
  SWFJpegBitmap jpeg;
  SWFShape shape = newSWFShape();
  SWFDisplayItem i;
  jpeg = newSWFJpegBitmapForFileName("test.jpg");
  if(!jpeg)
  {
    printf("Couldn't find test.jpg file!\n");
    printf("Press any key to exit\n");
    getchar();
    exit(1);
  }
  fill = SWFShape_addBitmapFill(shape, jpeg, SWFFILL_TILED_BITMAP);
  SWFShape_setRightFill(shape, fill);
  SWFShape_drawCharacterBounds(shape, (SWFCharacter)jpeg);

  i = SWFMovie_add(movie, shape);
  SWFDisplayItem_scale(i, 20.0, 20.0);
}

/* }}} */
/* {{{ testJpegAlpha */

void testJpegAlpha(SWFMovie movie)
{
  SWFFill fill;
  SWFJpegBitmap jpeg;
  SWFShape shape = newSWFShape();
  SWFDisplayItem i;
  jpeg=newSWFJpegWithAlphaForFileName("test.jpg","test.msk");
  fill = SWFShape_addBitmapFill(shape, jpeg, SWFFILL_TILED_BITMAP);
  SWFShape_setRightFill(shape, fill);
  SWFShape_drawCharacterBounds(shape, (SWFCharacter)jpeg);

  i = SWFMovie_add(movie, shape);
  SWFDisplayItem_scale(i, 20.0, 20.0);
}

/* }}} */
/* {{{ testText */

SWFDisplayItem testText(SWFMovie movie)
{
  // this and similar doesn't work if you try to call the routine
  // in a dll - file pointer gets passed to it fine but it 
  // seems it cant be used SWFFont f = loadSWFFontFromFile(fopen("verdana.fdb","rb"));
  SWFFont f =loadSWFFontFromFileOfName("verdana.fdb");
  SWFText t = newSWFText();
  SWFDisplayItem d;

  if(f == NULL)
  {
    printf("font def file not found!\n");
    printf("Press any key to exit\n");
    getchar();
    exit(1);
  }

  SWFText_setFont(t, f);
  SWFText_setHeight(t, 240);
  SWFText_setColor(t, 0, 0, 0, 0xff);
  SWFText_setSpacing(t, 0.5);
  SWFText_addString(t, "blargghghgghghgh", NULL);

  SWFText_setXY(t, -1, 480);
  SWFText_setHeight(t, 480);
  SWFText_setSpacing(t, 1.0);
  SWFText_addString(t, "blargghghgghghgh", NULL);

  d = SWFMovie_add(movie, t);
  SWFDisplayItem_move(d, 160*20, 120*20);
  return d;
}

SWFDisplayItem testTextTutorial(SWFMovie movie,byte rv,byte gv,byte bv,int height)
{
 char *szFontDef="verdana.fdb";
  SWFFont f = loadSWFFontFromFileOfName(szFontDef);
  SWFText t = newSWFText();
  SWFDisplayItem d;

  if(f == NULL)
  {
    printf("font def file \"%s\" not found!\n",szFontDef);
    printf("Press any key to exit\n");
    getchar();
    exit(1);
  }

  SWFText_setFont(t, f);
  SWFText_setHeight(t, (float)height);
  SWFText_setColor(t, rv,gv,bv, 0xff);
  {
   static int npos_spaces;
   char *msg="no, please!  not my toes!";
   char spaces[]="                                     ";
   char string[1024];
   strcpy(string,spaces);
   string[npos_spaces]='\0';
   strcat(string,msg);
   npos_spaces=(npos_spaces+1)%strlen(spaces);
   SWFText_addString(t,string, NULL);
  }

  d = SWFMovie_add(movie, t);
  SWFDisplayItem_move(d, 30,30);
  return d;
}


/* }}} */
/* {{{ testShape */

SWFDisplayItem testShape(SWFMovie movie)
{
  int i;
  SWFDisplayItem d;
  SWFShape s = newSWFShape();

  SWFFill f1 = SWFShape_addSolidFill(s, 0xff, 0, 0, 0xff);
  SWFFill f2 = SWFShape_addSolidFill(s, 0, 0, 0xff, 0xff);

  SWFShape_moveTo(s, -1200, -1200);
  SWFShape_setLineStyle(s, 20, 0, 0, 0, 0);
  SWFShape_setRightFill(s, f1);
  SWFShape_lineToRelative(s, 2400, 0);
  SWFShape_setRightFill(s, f2);
  SWFShape_lineToRelative(s, 0, 2400);
  SWFShape_setRightFill(s, f1);
  SWFShape_lineToRelative(s, -2400, 0);
  SWFShape_setRightFill(s, f2);
  SWFShape_lineToRelative(s, 0, -2400);
  SWFShape_end(s);

  d = SWFMovie_add(movie, s);

  for(i=0; i<45; ++i)
  {
    SWFDisplayItem_rotate(d, 360/45);
    SWFDisplayItem_move(d, 160*20, 120*20);
    SWFMovie_nextFrame(movie);
    SWFDisplayItem_move(d, -160*20, -120*20);
  }
  return d;
}


SWFShape SmallRectangle(byte rfill, byte gfill, byte bfill, byte afill
               ,byte routline, byte goutline, byte boutline, byte aoutline
               ,int pen_width,int indent
               )
{
   SWFShape shape = newSWFShape();
   SWFFill f1 = SWFShape_addSolidFill(shape, rfill, gfill, bfill, afill);

   SWFShape_setLine(shape, (unsigned short)pen_width, routline, goutline, boutline, aoutline);
   SWFShape_setRightFill(shape, f1);
   SWFShape_movePenTo(shape, (float)pen_width+indent, (float)pen_width+indent);
   SWFShape_drawLineTo(shape,(float) WIDTH-pen_width-indent, (float)pen_width+indent);
   SWFShape_drawLineTo(shape,(float) WIDTH-pen_width-indent, (float)HEIGHT-pen_width-indent);
   SWFShape_drawLineTo(shape, (float)pen_width+indent,(float) HEIGHT-pen_width-indent);
   SWFShape_drawLineTo(shape, (float)pen_width+indent, (float)pen_width+indent);
   SWFShape_end(shape);

   return shape;
}

SWFDisplayItem testSmallRectangle(SWFMovie movie,byte rfill, byte gfill, byte bfill, byte afill
               ,byte routline, byte goutline, byte boutline, byte aoutline
               ,int pen_width,int indent
               )
{
   SWFShape shape = SmallRectangle(rfill, gfill, bfill, afill
    ,routline, goutline, boutline, aoutline,pen_width,indent);
   return SWFMovie_add(movie, shape);
}

SWFDisplayItem testRectangle(SWFMovie movie,byte rfill, byte gfill, byte bfill, byte afill
               ,byte routline, byte goutline, byte boutline, byte aoutline
               ,int pen_width
               )
{
 return testSmallRectangle(movie,rfill, gfill, bfill, afill
               ,routline, goutline, boutline, aoutline
               ,pen_width,0
               );

}

SWFDisplayItem testGradientFillRectangle(SWFMovie movie,byte rfill, byte gfill, byte bfill, byte afill
               ,byte rfill2, byte gfill2, byte bfill2, byte afill2
               ,byte routline, byte goutline, byte boutline, byte aoutline
               ,int width
               ,int degrees
               )
{

   SWFShape shape = newSWFShape();
   SWFGradient gradient=newSWFGradient();
   SWFFill f1;
   SWFGradient_addEntry(gradient,0.0, rfill, gfill, bfill, afill);
   SWFGradient_addEntry(gradient,1.0, rfill2, gfill2, bfill2, afill2);
   f1 =SWFShape_addGradientFill(shape,gradient, SWFFILL_LINEAR_GRADIENT );
   SWFFill_moveTo(f1,WIDTH/2,HEIGHT/2);
   degrees=degrees%360;
   if(degrees<0)
    degrees+=360;
   SWFFill_rotate(f1,(float)degrees);
   // if((degrees>90-45&&degrees<90+45)||(degrees>270-45&&degrees<270+45))
   {
    float ratioa=max(1,WIDTH*Ming_getScale())/(float)32768;
    float ratiob=max(1,HEIGHT*Ming_getScale())/(float)32768;
    SWFFill_scaleTo(f1,ratioa,ratiob);
   }
   SWFShape_setRightFill(shape, f1);
   SWFShape_setLine(shape, (unsigned short)width, routline, goutline, boutline, aoutline);
   SWFShape_movePenTo(shape, (float)width, (float)width);
   SWFShape_drawLineTo(shape, (float)WIDTH-width, (float)width);
   SWFShape_drawLineTo(shape,(float) WIDTH-width, (float)HEIGHT-width);
   SWFShape_drawLineTo(shape, (float)width, (float)HEIGHT-width);
   SWFShape_drawLineTo(shape, (float)width, (float)width);
   SWFShape_end(shape);

   return SWFMovie_add(movie, shape);
}

/* }}} */



/* {{{ testMp3 */

void testMp3(SWFMovie movie)
{
  SWFSound sound;
  sound = newSWFSoundForFileName("test.mp3");
  if(!sound)
  {
    printf("Couldn't find test.mp3 file\n");
    printf("Press any key to exit\n");
    // note - this is needed in Windows if you run the program by file 
    // association or from within a debugger - because otherwise its
    // console closes before you have time to see the text - this happens
    // when the program exits.
    getchar();
    exit(1);
  }
  SWFMovie_setSoundStream(movie, sound);
  SWFMovie_setNumberOfFrames(movie, 200);
}
#define TUT_SHAPE 0
#define TUT_MORPH 1
#define TUT_TEST 2
#define TUT_DEMO 3
#define TUT_TEST_MASK 4
#define TUT_TEST_MASK_TEXT 5
#define TUT_TEST_JPG 6
#define TUT_TEST_PNG 7
#define TUT_TEST_BUTTON 8

void DoTutEtc(SWFMovie movie,int itut)
{
 // from http://ming.sourceforge.net/examples/index.html
 switch(itut)
 {
 case TUT_SHAPE:
  {
   SWFShape s = newSWFShape();
   SWFShape_setLine(s,4, 0x7f, 0, 0,255);
   SWFShape_setRightFill(s,SWFShape_addSolidFill(s, 0xff, 0, 0,255));
   SWFShape_movePenTo(s,10, 10);
   SWFShape_drawLineTo(s,310, 10);
   SWFShape_drawLineTo(s,310, 230);
   SWFShape_drawCurveTo(s,10, 230, 10, 10);
   SWFMovie_add(movie, s);
   SWFMovie_nextFrame(movie);
   break;
  }
 case TUT_MORPH:
  {
   double ratio=0;
   SWFDisplayItem d;
   SWFMorph morph = newSWFMorphShape();
   SWFShape s1 = SWFMorph_getShape1(morph);
   SWFShape s2 = SWFMorph_getShape2(morph);
   SWFShape_setLine(s1,0,0,0,0,255);
   SWFShape_setLeftFill(s1,SWFShape_addSolidFill(s1,0xff, 0, 0,255));
   SWFShape_movePenTo(s1,-100,-100);
   SWFShape_drawLine(s1,200,0);
   SWFShape_drawLine(s1,0,200);
   SWFShape_drawLine(s1,-200,0);
   SWFShape_drawLine(s1,0,-200);
   SWFShape_setLine(s2,6,0,0,0,255);
   SWFShape_setLeftFill(s2,SWFShape_addSolidFill(s2,0, 0, 0xff,255));
   SWFShape_movePenTo(s2,0,-100);
   SWFShape_drawLine(s2,100,100);
   SWFShape_drawLine(s2,-100,100);
   SWFShape_drawLine(s2,-100,-100);
   SWFShape_drawLine(s2,100,-100);
   d=SWFMovie_add(movie, morph);
   SWFDisplayItem_moveTo(d,WIDTH/2,HEIGHT/2);
   for(ratio=0.0; ratio<=1.0; ratio+=0.1)
   {
    SWFDisplayItem_setRatio(d,(float)ratio);
    SWFMovie_nextFrame(movie);
   }
  }
  break;
 case TUT_TEST:
  // testCubic(movie);
  testDrawCharacter(movie);
  // testMorph(movie);
  // testShape(movie);
  // testText(movie);
  // testDBL(movie); // PNG
  // testJpeg(movie);
  //testJpegAlpha(movie);
   SWFMovie_nextFrame(movie);
   break;
 case TUT_TEST_MASK:
  {   
   SWFDisplayItem d=testSmallRectangle(movie,255,255,255,255
              ,255,255,255, 255
              ,20,100);
   SWFDisplayItem dtext = testTextTutorial(movie,255,0,0,HEIGHT/2);
   SWFMovie_nextFrame(movie);
   MingRemoveAllDisplayItems(0);
   break;
  }
 case TUT_TEST_JPG:
  { 
   testJpegFilledRectangle
     (movie,"test.jpg"
     ,128,0, 255, 255
     ,8
     );
   SWFMovie_nextFrame(movie);
   MingRemoveAllDisplayItems(0);
   break;
  }
 case TUT_TEST_PNG:
  { 
   int nframes=36;
   int i=0;
   SWFDisplayItem d = testPngFilledRectangle
     (movie,"test.dbl"
     ,128,0, 255, 255
     ,8
     );
   SWFDisplayItem_moveTo(d, (float)(WIDTH/2),(float)(HEIGHT/2));
   SWFDisplayItem_scaleTo(d,(float)0.4,(float)0.4);
   for(i=0;i<nframes;i++)
   {
    int iincr=i;
    SWFDisplayItem_rotateTo(d,(float)i*10);
    SWFMovie_nextFrame(movie);
   }
   d = testPngFilledRectangle
     (movie,"test.dbl"
     ,128,0, 255, 255
     ,8
     );
   SWFDisplayItem_moveTo(d, (float)(WIDTH/2),(float)(HEIGHT/2));
   SWFDisplayItem_scaleTo(d,(float)0.4,(float)0.4);
   for(i=0;i<nframes;i++)
   {
    int iincr=i;
    SWFDisplayItem_rotateTo(d,(float)i*10);
    SWFMovie_nextFrame(movie);
   }
   MingRemoveAllDisplayItems(0);
   break;
  }
  case TUT_TEST_MASK_TEXT:
  { 
   int nframes=1000;
   int mult=2;
   int i=0;
   SWFDisplayItem d = testTextTutorial(movie,255,0,0,HEIGHT/2);
   SWFMovie_setRate(movie,20);
   testJpegFilledRectangle
     (movie,"test.jpg"
     ,128,0, 255, 255
     ,8
     );
   SWFDisplayItem_setMaskLevel(d,2);
   SWFMovie_nextFrame(movie);
   for(i=0;i<nframes;i++)
   {
    int iincr=i;
    SWFDisplayItem_moveTo(d, (float)(((iincr*10)%(WIDTH)-100)),(float)(((iincr*3)%(HEIGHT-60))));
    SWFDisplayItem_scaleTo(d,(float)(nframes-mult*i)/nframes,(float)(nframes-mult*2*i)/nframes);
    SWFDisplayItem_setColorAdd(d,-(byte)(iincr*10),0,(byte)(iincr*10),-(byte)(iincr*5));
    SWFMovie_nextFrame(movie);
   }
   MingRemoveAllDisplayItems(0);
   break;
  }
 case TUT_TEST_BUTTON:
  // http://ming.sourceforge.net/examples/example.php?name=button
  {
   SWFButton button = newSWFButton();
   SWFShape shape=SmallRectangle(255,0,0,255
              ,0,255,255, 255
              ,20,100);
   SWFButton_addShape(button,shape,SWFBUTTON_UP);
   shape=SmallRectangle(255,0,255,255
              ,0,255,0, 255
              ,20,100);
   SWFButton_addShape(button,shape,SWFBUTTON_DOWN);
   shape=SmallRectangle(255,255,0,255
              ,0,0,255, 255
              ,20,100);
   SWFButton_addShape(button,shape,SWFBUTTON_OVER);
   shape=SmallRectangle(0,255,0,255
              ,255,0,255, 255
              ,20,100);
   SWFButton_addShape(button,shape,SWFBUTTON_HIT);
   SWFMovie_add(movie,button);
   SWFMovie_nextFrame(movie);
   break;
  }
 case TUT_DEMO:
  {   
   int nframes=3*240;
   int i=0,iwas=0;
   SWFMovie_setNumberOfFrames(movie, nframes);
   testMp3(movie);
   for(i=0;i<nframes/4;i++)
   {
    {
     SWFDisplayItem d=testSmallRectangle(movie,255,255,255,255
                ,255,255,255, 255
                ,20,70);
     SWFDisplayItem_setMaskLevel(d,2);
    }
    testGradientFillRectangle(movie, 0, 128, 255, 255
               ,255, 255,255,255
               ,(byte)(i*10),(byte)(i*10), 255, 255
               ,20
               ,i*10
               );
    SWFMovie_nextFrame(movie);
    MingRemoveAllDisplayItems(0);
   }
   /**/
   /**/
   iwas=i;
   for(;i<nframes/2;i++)
   {
    int iincr=i-iwas;
    testRectangle(movie, (byte)(iincr*8), 128, 255, 255
              ,128, (byte)(iincr*8), 255, 255
              ,(byte)(iincr*8));
    SWFMovie_nextFrame(movie);
    MingRemoveAllDisplayItems(0);
   }
   /**/
   /**/
   iwas=i;
   MingForgetDisplayItem
    (testJpegFilledRectangle
     (movie,"test.jpg"
     ,128,0, 255, 255
     ,8
     )
    );
   for(;i<3*nframes/4;i++)
   {
    int iincr=i-iwas;
    testSmallRectangle(movie, (byte)(iincr*8), 128, 255, 255
               ,128, (byte)(iincr*8), 255, 255
               ,(byte)(iincr*8),iincr);
    SWFMovie_nextFrame(movie);
    MingRemoveAllDisplayItems(0);
    i++;
   }
   MingRemoveAllDisplayItems(1/*remove_forgotten_items*/);
   {
    SWFDisplayItem d=testGradientFillRectangle
      (movie, 128, 255, 0, 255
      ,0, 128,255,255
      ,(byte)(i*10),(byte)(i*10), 255, 255
      ,20
      ,90
      );
    SWFDisplayItem_move(d,WIDTH/6,HEIGHT/6);
    MingForgetDisplayItem(d);
    iwas=i;
    for(;i<5*nframes/6;i++)
    {
     int iincr=i-iwas;
     SWFDisplayItem_rotateTo(d,(float)(90+10*iincr));
     testSmallRectangle(movie, (byte)(iincr*8), 128, 255, 255
                ,128, (byte)(iincr*8), 255, 255
                ,(byte)(iincr*8),iincr);
     SWFMovie_nextFrame(movie);
     MingRemoveAllDisplayItems(0);
     i++;
    }
    MingRemoveAllDisplayItems(1/*remove_forgotten_items*/);
   }
   iwas=i;
   {
    SWFDisplayItem d = testTextTutorial(movie,255,0,0,20);
    for(;i<nframes;i++)
    {
     int iincr=i-iwas;
     SWFDisplayItem_moveTo(d, (float)((30+(iincr*10)%(WIDTH-60))),(float)((30+(iincr*3)%(HEIGHT-60))));
     SWFDisplayItem_setColorAdd(d,-(byte)(iincr*10),0,(byte)(iincr*10),-(byte)(iincr*5));
     SWFMovie_nextFrame(movie);
    }
   }
  }
 }
}

/* }}} */

void cleanup(void);

int main(int argc, char *argv[])
{
// FILE *f;
 SWFMovie movie = newSWFMovie();
 int length;
#ifdef cl_win
#ifdef _DEBUG
#ifdef cl_MSVC_debug_mem_leak_tests
 {
  // check for memory leaks
  int tmpFlag = _CrtSetDbgFlag( _CRTDBG_REPORT_FLAG );
  tmpFlag |= _CRTDBG_LEAK_CHECK_DF|_CRTDBG_CHECK_ALWAYS_DF;
  _CrtSetDbgFlag( tmpFlag );
}
#endif
#endif
#endif
  atexit(cleanup);
  Ming_init();

  srand(time(NULL));

  SWFMovie_setRate(movie,6);
  SWFMovie_setDimension(movie, WIDTH, HEIGHT);
  Ming_setScale(20.0);
  DoTutEtc(movie,TUT_DEMO);
  MingRemoveAllDisplayItems(0);
  length = SWFMovie_output_for_file_name(movie,"test.swf");
  destroySWFMovie(movie);
  printf("%i bytes written\n", length);
  printf("\npress any key to exit\n");
    // note - this is needed in Windows if you run the program by file 
    // association or from within a debugger - because otherwise its
    // console closes before you have time to see the text - this happens
    // when the program exits.
  getchar();
  exit(0);
  // note - then it does the cleanup() below
}

void cleanup(void)
{
 // Ming_cleanup();
 // try the effect of this without clean up, in debug mode
 // with cl_mem_leak_check defined in "_cl.h" to see the memory leak
 // - however - this memory gets auto freed in Windows
 // (I was mistaken when I thought that it got left around
 // on exit) - so not so important to do this really!
#ifdef cl_mem_leak_check
 if(Ming_MemLeakCheckAndFree())
 {
  printf("\npress any key to exit\n");
  getchar();
 }
#endif
}
